#include <qfiledlg.h>
#include <qfiledef.h>
#include <qwidget.h>
#include <ktopwidget.h>
#include <kapp.h>
#include <kwm.h>
#include <kkeyconf.h>
#include "ksimpledlg.h"
#include "kdepopup.h"

#define SMB_BUFSIZE	65536

Window w;

kdepopup :: kdepopup(QWidget *parent, const char *name)
	: KTopLevelWidget(name)

{
char pa[1024];

	menubar=new KMenuBar(this);
	fileMenu=new QPopupMenu;
	menubar->insertItem("&File",fileMenu);
	fileMenu->insertItem("&New message",this,SLOT(newsmbw()),CTRL + Key_N);
	fileMenu->insertSeparator();
	fileMenu->insertItem("&Close",this,SLOT(iconify()),CTRL + Key_W);
	fileMenu->insertItem("&Quit",KApplication::getKApplication(),
		SLOT(quit()),CTRL + Key_Q);
	menubar->show();
	setMenu(menubar);

/*
	statusbar=new KStatusBar(this);
	statusbar->insertItem("Status",1);
	statusbar->show();
	setStatusBar(statusbar);
*/

	label=new QLabel(this);
//	label->setText("fasel");
	sprintf(pa,"%s/share/apps/kdepopup/sambaani64.gif",kapp->kdedir().data());
	label->setPixmap(pa);
	label->setAlignment(AlignCenter);
	label->setMargin(10);
	label->resize(label->sizeHint());
	label->move(0,menubar->height());
//	setView(label);
	resize(label->width(),label->height()+menubar->height());

	sock=new KServerSocket(4414);
	connect(sock,SIGNAL(accepted(KSocket *)),SLOT(sock_conn(KSocket *)));
}


kdepopup :: ~kdepopup()
{
}


void kdepopup :: newsmbw()
{
	kw=new ksmbWindow(0,0,0,1);
	kw->setCaption("New message");
	
}

ksmbWindow :: ksmbWindow(QWidget *parent, const char *name,QMultiLineEdit *olist,
	int flag, char *ofrom, char *oto, char *ohost)
{
	from=new char[1024];
	to=new char[1024];
	host=new char[1024];
	if (ofrom) strcpy(from,ofrom); else *from=0;
	if (oto) strcpy(to,oto); else *to=0;
	if (ohost) strcpy(host,ohost); else *host=0;

	menubar=new KMenuBar(this);
	fileMenu=new QPopupMenu;
	menubar->insertItem("&File",fileMenu);
	if (flag) {
		fileMenu->insertItem("&Host...",this,SLOT(edithost()),CTRL + Key_H);
		fileMenu->insertItem("&Send",this,SLOT(msgsend()),CTRL + Key_D);
	} else {
		fileMenu->insertItem("&Reply",this,SLOT(answer()),CTRL + Key_R);
		fileMenu->insertItem("&Save",this,SLOT(msgsave()),CTRL + Key_S);
	}
	fileMenu->insertItem("C&lear",this,SLOT(msgclear()),CTRL + Key_L);
	fileMenu->insertSeparator();
	fileMenu->insertItem("&Close",this,SLOT(close()),CTRL + Key_W);
	menubar->show();
	setMenu(menubar);

	statusbar=new KStatusBar(this);
	statusbar->insertItem("Status",1);
	statusbar->show();
	setStatusBar(statusbar);

	textw=new QMultiLineEdit(this);
	if (!flag)
		textw->setReadOnly(TRUE);
	textw->setAutoUpdate(TRUE);
	setView(textw);
	if (olist) fill(olist);
	show();

}

void ksmbWindow :: answer()
{
	kw=new ksmbWindow(0,0,textw,1,from,to,host);
	
}

void ksmbWindow :: msgclear()
{
	textw->clear();
}

void ksmbWindow :: msgsave()
{
	msgsavef();
}

void ksmbWindow :: edithost()
{
char buffer[128];

	ksimpledialog *ho=new ksimpledialog(0,"Enter hostname to send message to",TRUE);
//	ksimpledialog *ho=new ksimpledialog;
	ho->setlabel("Enter hostname to send message to");
	ho->setvalue(host);
	ho->exec();
	strcpy(host,ho->getvalue());
	delete ho;
	sprintf(buffer,"New message to %s",host);
	setCaption(buffer);

}

void ksmbWindow :: msgsavef(QString *filename=0)
{

#define MAXLENGTH	1024

int i,fd,do_del;
char p[MAXLENGTH];

	do_del=0;
	if (!filename) {
		filename=new QString(QFileDialog::getSaveFileName("",
		"*",0,"save message to ..."));
		do_del=1;
		}

	if (!filename->isEmpty()) {
		fd=::open(filename->data(),O_WRONLY|O_CREAT|O_TRUNC,0666);
		if (fd>=0) {
			for (i=0;i<textw->numLines();i++) {
				snprintf(p,MAXLENGTH-1,"%s\n",textw->textLine(i));
				::write(fd,p,strlen(p));
				}
			::close(fd);
			}
		} else {
			printf("not opened\n");
		}
	if (do_del) delete filename;
}

ksmbWindow :: fill(QMultiLineEdit *list)
{
int i;
char buffer[1024];

	for (i=0;i<list->numLines();i++) {
		sprintf(buffer,"> %s",list->textLine(i));
		textw->insertLine(buffer);
		}
	sprintf(buffer,"Reply to message from %s at %s to %s",from,host,to);
	setCaption(buffer);
}

ksmbWindow :: ~ksmbWindow()
{
	delete from,to,host;
	delete statusbar;
	delete fileMenu;
	delete menubar;
}

void ksmbWindow :: msgsend()
{
char buf[1024];

	QString *filen=new QString("/tmp/kdepopup.tmp");
	msgsavef(filen);
	sprintf(buf,"sh -c \"smbclient -M %s < %s\"",host,filen->data());
	system(buf);
	delete filen;
	close();
}

void ksmbWindow :: close()
{
	delete this;
}
 
void kdepopup :: iconify()
{
	KWM::setIconify(w,TRUE);
}

void ksmbWindow :: readfromsocket(KSocket *k)
{
int rc,s;
char *p,*q;

	char *buf=new char[SMB_BUFSIZE+1];
//	KWM::activate(w);
	s=k->socket();
	p=buf;
	while (1) {
		rc=read(s,p,SMB_BUFSIZE-(p-buf));
		*(p+rc)=0;
		if (!rc) break;
		p+=rc;
		}

	p=buf;
	if (p && !strncmp(p,"FROM:",5)) {
		q=p+5; p=strchr(q,'\n');
		if (p) *p++=0;
		strcpy(from,q);
		}
	if (p && !strncmp(p,"TO:",3)) {
		q=p+3; p=strchr(q,'\n');
		if (p) *p++=0;
		strcpy(to,q);
		}
	if (p && !strncmp(p,"HOST:",5)) {
		q=p+5; p=strchr(q,'\n');
		if (p) *p++=0;
		strcpy(host,q);
		}
	if (p) textw->insertLine(p);

	sprintf(buf,"Message from %s at %s to %s",from,host,to);
	setCaption(buf);
	delete buf;
}

void kdepopup :: sock_conn(KSocket *k)
{
int rc,s;
char *p,*q,from[128],to[128],host[128];

	kw=new ksmbWindow();
	kw->readfromsocket(k);

	delete k;

}

int main(int argc, char* argv[])
{
int rc;

	KApplication *app=new KApplication(argc,argv);
	kdepopup *smb=new kdepopup;

	app->setMainWidget(smb);
	smb->show();

	w=KWM::activeWindow();
	KWM::setIconify(w,TRUE);

	rc=app->exec();

	return(rc);
}

